﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace lift
{
    class Menet
    {
        public int Ora { get; set; }
        public int Perc { get; set; }
        public int Mp { get; set; }
        public int Csapat { get; set; }
        public int Ind { get; set; }
        public int Érk { get; set; }
        public Menet(string[] adat)
        {
            Ora = Convert.ToInt32(adat[0]);
            Perc = Convert.ToInt32(adat[1]);
            Mp = Convert.ToInt32(adat[2]);
            Csapat = Convert.ToInt32(adat[3]);
            Ind = Convert.ToInt32(adat[4]);
            Érk = Convert.ToInt32(adat[5]);
        }
        public Menet() { }
    }
    class Program
    {
        static void Main(string[] args)
        {
            #region 1. feladat - beolvasás
            StreamReader be = new StreamReader("igeny.txt");
            int mszint = Convert.ToInt32(be.ReadLine());
            int csdb = Convert.ToInt32(be.ReadLine());
            int db = Convert.ToInt32(be.ReadLine()) + 1;
            string sor;
            Menet[] igeny = new Menet[db];
            for (int i = 1; i < db; i++)
            {
                sor = be.ReadLine();
                igeny[i] = new Menet(sor.Split(' '));
            }
            be.Close();
            #endregion
            #region 2. feladat - beolvasás
            Console.WriteLine("2. feladat: Kérem a lift indulási helyét!");
            string kezdet = Console.ReadLine();
            igeny[0] = new Menet(("0 0 0 0 " + kezdet + " " + kezdet).Split(' '));
            #endregion
            #region 3. feladat - utolsó szint
            Console.WriteLine("3. feladat");
            Console.WriteLine("A lift a(z) " + igeny[db - 1].Érk + ". szinten áll az utolsó igény teljesítése után.");
            #endregion
            #region 4. feladat - szélső szintek
            Console.WriteLine("4. feladat");
            int minh = 0;
            int maxh = 0;
            for (int i = 1; i < db; i++)
            {
                if (Math.Max(igeny[i].Ind, igeny[i].Érk) > Math.Max(igeny[maxh].Ind, igeny[minh].Érk))
                {
                    maxh = i;
                }
                if (Math.Min(igeny[i].Ind, igeny[i].Érk) < Math.Min(igeny[minh].Ind, igeny[minh].Érk))
                {
                    minh = i;
                }
            }
            Console.WriteLine("Legmagasabb szint: {0}\t\tLegalacsonyabb szint: {1}", Math.Max(igeny[maxh].Ind, igeny[minh].Érk), Math.Min(igeny[minh].Ind, igeny[minh].Érk));
            #endregion
            #region 5. feladat - felfelé
            Console.WriteLine("5. feladat");
            int ures = 0;
            int tele = 0;
            for (int i = 1; i < db; i++)
            {
                if (igeny[i - 1].Érk < igeny[i].Ind)
                {
                    ures++;
                }
                if (igeny[i].Ind < igeny[i].Érk)
                {
                    tele++;
                }
            }
            Console.WriteLine("Utassal {0}, utas nélkül {1} alkalommal indult felfelé a lift.", tele, ures);
            #endregion
            #region 6. feladat - nem használó
            int[] használdb = new int[csdb + 1]; //vsz nincs 0. csapat
            for (int i = 0; i < csdb + 1; i++)
            {
                használdb[i] = 0;
            }
            for (int i = 1; i < db; i++)
            {
                használdb[igeny[i].Csapat]++;
            }
            for (int i = 1; i < csdb + 1; i++)
            {
                if (használdb[i] == 0)
                {
                    Console.Write(i + ", ");
                }
            }
            Console.WriteLine("\b\b ");
            #endregion
            #region 7. feladat - liftkerülő
            Random r = new Random();
            int teszt = r.Next(csdb) + 1;
            Console.WriteLine("7. feladat: a csapat száma: " + teszt);
            int j = 1;
            while (j < db && igeny[j].Csapat != teszt)
            {
                j++;
            }
            if (j == db)
            {
                Console.WriteLine("Nem bizonyítható szabálytalanság");

            }
            else
            {
                bool van = false;
                int kiszáll = igeny[j].Érk;
                for (int i = j + 1; i < db; i++)
                {
                    if (igeny[i].Csapat == teszt)
                    {
                        if (igeny[i].Ind != kiszáll)
                        {
                            Console.WriteLine("{0} és {1} között", kiszáll, igeny[i].Ind);
                            van = true;
                        }
                        kiszáll = igeny[i].Érk;
                    }

                }
                if (!van)
                {
                    Console.WriteLine("Nem bizonyítható szabálytalanság");
                }
            }
            #endregion
            #region 8. feladat - alibi blokkolás
            Console.WriteLine("8. feladat");
            StreamWriter ki = new StreamWriter("blokkol.txt");
            for (int i = 1; i < db; i++)
            {
                if (igeny[i].Csapat == teszt)
                {
                    ki.WriteLine("Befejezés ideje: {0}:{1}:{2}", igeny[i].Ora, igeny[i].Perc, igeny[i].Mp);
                    ki.WriteLine("Sikeresség: {0}", r.Next(2) == 1 ? "befejezett" : "befejezetlen");
                    ki.WriteLine("-----");
                    ki.WriteLine("Indulási emelet: {0}", igeny[i].Ind);
                    ki.WriteLine("Célemelet: {0}", igeny[i].Érk);
                    ki.WriteLine("Feladatkód: {0}", r.Next(99) + 1);
                }
            }
            ki.Close();
            Console.WriteLine("A kiírás befejeződött.");
            #endregion
            Console.ReadLine();
        }
    }
}
